ushort
    VERSION1 = 2,	/* version 2.0 */
    VERSION2 = 0,
    COMMANDCOUNT = 75,	/* number of commands in command table */
    SECONDCHARCOUNT = 6,/* number of 2nd common escape chars allowed */
    NCOLUMNS = 80,	/* number of columns displayable */
    MINIMUM_WINDOW_HEIGHT = 10; /* smallest window when splitting */

ushort
    INSERTCOL = 1,
    WRAPCOL = 2,
    MULTICOL = 3,
    REGIONCOL = 4,
    LINECOL = 6,
    COLCOL = LINECOL + 6,
    NAMECOL = COLCOL + 3;

ushort
    SEARCHLENGTH = NCOLUMNS - 1,
    DEFAULTINDENTINCREMENT = 4, 	/* amount of each indent unit */
    DEFAULTWRAPCOLUMN = NCOLUMNS - 1;	/* column to word wrap at */

char
    BEEP = '\(0x07)';

type
    LINELIST = struct {
	*LINELIST l_next;
	*LINELIST l_prev;
	*char l_data;
    },

    TABMODE = enum {BLANKS, TABS, COUNTS},

    BUFFERLIST = struct {
	*BUFFERLIST
	    b_next,			/* pointer to previous buffer */
	    b_prev,			/* pointer to next buffer */
	    b_sNext,			/* next buffer on screen (circle) */
	    b_sPrev;			/* previous buffer on screen */
	*LINELIST
	    b_lines,			/* head of list of lines */
	    b_currentLine,		/* pointer to line for current */
	    b_regionPtr;		/* pointer to line of first end */
	*char
	    b_fileName, 		/* name of file being edited */
	    b_regionPos;		/* pointer to char of first end */
	ulong
	    b_lineCount,		/* number of lines in file */
	    b_cursorLine,		/* line in file the cursor is in */
	    b_changeCount,		/* number of line changes */
	    b_regionLine,		/* line of first end */
	    b_LRU;			/* used when picking window to zap */
	ushort
	    b_windowHeight,		/* number of lines in screen window */
	    b_windowPos,		/* screen line of first window line */
	    b_windowLine,		/* line in window the cursor is in */
	    b_cursorColumn,		/* column in window the cursor is in */
	    b_indentAmount,		/* amount of current auto-indent */
	    b_indentIncrement,		/* amount of each indent step */
	    b_wrapColumn,		/* column to do word-wrap at */
	    b_regionColumn;		/* column of first end */
	TABMODE b_tabMode;		/* how to handle tabs in file */
	bool
	    b_isFile,			/* true => has associated file */
	    b_newFile,			/* true => edit file is a new file */
	    b_insertMode,		/* true => typing in insert mode */
	    b_wrapMode, 		/* true => wrap at b_wrapColumn */
	    b_multiColumn,		/* true => multi-column enabled */
	    b_gotRegion;		/* true => have first region end */
    },

    COMMANDENTRY = struct {
	ushort c_mode;
	char c_char;
    },

    COMMANDTABLE = struct {
	ushort c_secondCount;
	char c_escapeA;
	char c_escapeB;
	char c_escapeC;
	char c_terminator;
	[SECONDCHARCOUNT] char c_escape2;
	[COMMANDCOUNT] COMMANDENTRY c_commands;
    };

*COMMANDTABLE CommandTable;		/* table of commands codes */

*BUFFERLIST BufferList; 		/* list of active buffers */
*BUFFERLIST ScreenList; 		/* list of buffers on screen */
*BUFFERLIST BufferPtr;			/* pointer to current on in list */
BUFFERLIST CurrentBuffer;		/* copy of current buffer */

channel input text Chin;		/* channel to read files */
channel output text Chout @ Chin;	/* channel to write files */
file(1000) Fyle;			/* file for disk I/O */

[NCOLUMNS] char LineBuffer;		/* buffer for line operations */
[NCOLUMNS] char TempBuffer;		/* buffer for scratch purposes */
[SEARCHLENGTH] char Subject;		/* subject string for searching */
[SEARCHLENGTH] char Object;		/* 'to' string for change */
[NCOLUMNS] bool TabStops;		/* logical tabstops */

*LINELIST
    TextLines;				/* lines yanked out of file */

*char
    TextChars,				/* line portion yanked out */
    CursorPos;				/* pointer to current character */

ulong
    LRUCount;				/* counter of window changes */

ushort
    NLines,				/* number of lines on screen */
    LineLength, 			/* length of line in LineBuffer */
    SubjectLength;			/* length of search subject */

bool
    NoMemory,				/* true => op'n caused memory out */
    TooLong,				/* true => a line was too long */
    LineFixed,				/* true => line properly in list */
    LineChanged,			/* true => line has been changed */
    Searching,				/* true => have a search subject */
    Changing,				/* true => have a 'to' string */
    GotText;				/* true => have text text buffer */
