#drinc:util.g
#drinc:crt.g
#ded.g

/*
 * DEDR.DRC - routines in Draco editor for dealing with regions.
 */

extern
    noSpace()void,
    noRegion()void,
    noText()void,
    putError(*char message)void,
    freeString(*char p)void,
    fixPosition()void,
    unFixLine()void,
    fixLine()void,
    update()void,
    moveUpOne()void,
    deleteChunk(*char startPos, endPos; bool needRedraw)void,
    insertChunk(*char textPtr; bool needRedraw)void,
    insertBlanks(ushort count; bool needRedraw)void,
    deleteChar()void,
    displayNew()void,
    redraw()void,
    displayBottom(ushort startLine)void,
    regionStatus()void,
    getNumber(*char prompt)ulong,
    getFileName(*char prompt)bool,
    ask(*char question)bool,
    buildCopy(*LINELIST lines; **LINELIST pHead, pTail)ulong,
    insertLines(ulong count; *LINELIST head, tail)void,
    clearMemory(*LINELIST l)void,
    carriageReturn()void,
    dataChar(char ch)void,
    readData(**LINELIST pHead, pTail; ulong maxCount)ulong,
    writeFile(*LINELIST l)bool,
    adjustLine(bool needRedraw)void;

/*
 * gotoRegion - move cursor to the previously selected position.
 */

proc gotoRegion()void:

    if not CurrentBuffer.b_gotRegion then
	noRegion();
    else
	fixLine();
	CurrentBuffer.b_currentLine := CurrentBuffer.b_regionPtr;
	CurrentBuffer.b_cursorColumn := CurrentBuffer.b_regionColumn;
	CursorPos := CurrentBuffer.b_regionPos;
	if
	    if CurrentBuffer.b_cursorLine >= CurrentBuffer.b_regionLine then
		CurrentBuffer.b_cursorLine - CurrentBuffer.b_regionLine <=
		    CurrentBuffer.b_windowLine
	    else
		CurrentBuffer.b_regionLine - CurrentBuffer.b_cursorLine <=
		    CurrentBuffer.b_windowHeight - CurrentBuffer.b_windowLine
	    fi
	then
	    CurrentBuffer.b_windowLine :=
		if CurrentBuffer.b_cursorLine >=CurrentBuffer.b_regionLine then
		    CurrentBuffer.b_windowLine -
			make(CurrentBuffer.b_cursorLine -
			     CurrentBuffer.b_regionLine, ushort)
		else
		    CurrentBuffer.b_windowLine +
			make(CurrentBuffer.b_regionLine -
			     CurrentBuffer.b_cursorLine, ushort)
		fi;
	    CurrentBuffer.b_cursorLine := CurrentBuffer.b_regionLine;
	else
	    CurrentBuffer.b_cursorLine := CurrentBuffer.b_regionLine;
	    displayNew();
	fi;
    fi;
corp;
		
/*
 * freeText - free any existing text buffer.
 */

proc freeText()void:

    if GotText then
	GotText := false;
	if TextChars ~= nil then
	    freeString(TextChars);
	    TextChars := nil;
	else
	    clearMemory(TextLines);
	    TextLines := nil;
	fi;
    fi;
corp;

/*
 * grabRegion - common code for yankRegion and copyRegion.
 */

proc grabRegion(bool isYank)void:
    *LINELIST temp, dummy;
    register ulong count;
    ushort t;
    char ch;

    if not CurrentBuffer.b_gotRegion then
	noRegion();
    else
	freeText();
	unFixLine();
	fixPosition();
	if CurrentBuffer.b_cursorLine > CurrentBuffer.b_regionLine or
		CurrentBuffer.b_cursorLine = CurrentBuffer.b_regionLine and
		    CurrentBuffer.b_cursorColumn =
			 CurrentBuffer.b_regionColumn then
	    /* we are getting one or more complete lines */
	    GotText := true;
	    fixLine();
	    if isYank then
		/* yanking out a region of lines */
		CurrentBuffer.b_changeCount := CurrentBuffer.b_changeCount + 1;
		count := 1;
		TextLines := CurrentBuffer.b_regionPtr;
		while TextLines ~= CurrentBuffer.b_currentLine do
		    TextLines := TextLines*.l_next;
		    count := count + 1;
		od;
		CurrentBuffer.b_lineCount := CurrentBuffer.b_lineCount - count;
		CurrentBuffer.b_cursorLine :=
			CurrentBuffer.b_cursorLine - count;
		if CurrentBuffer.b_regionPtr*.l_prev = nil then
		    CurrentBuffer.b_lines :=
			    CurrentBuffer.b_currentLine*.l_next;
		else
		    CurrentBuffer.b_regionPtr*.l_prev*.l_next :=
			    CurrentBuffer.b_currentLine*.l_next;
		fi;
		if CurrentBuffer.b_currentLine*.l_next ~= nil then
		    TextLines := CurrentBuffer.b_currentLine;
		    CurrentBuffer.b_currentLine :=
			    CurrentBuffer.b_currentLine*.l_next;
		    CurrentBuffer.b_currentLine*.l_prev :=
			 CurrentBuffer.b_regionPtr*.l_prev;
		    TextLines*.l_next := nil;
		    CurrentBuffer.b_cursorLine :=
			    CurrentBuffer.b_cursorLine + 1;
		    if count <= CurrentBuffer.b_windowLine then
			/* there are lines in the window in front of the ones
			   being excised - scroll the tail up, and redraw the
			   newly blank space */
			CRT_ScrollRegionUp(
			    CurrentBuffer.b_windowPos +
				CurrentBuffer.b_windowLine - count + 1,
			    CurrentBuffer.b_windowHeight -
				CurrentBuffer.b_windowLine + count - 1,
			    count);
			CurrentBuffer.b_windowLine :=
			    CurrentBuffer.b_windowLine - count + 1;
			displayBottom(CurrentBuffer.b_windowHeight - count);
		    else
			/* just scroll the whole window up and redraw tail */
			CRT_ScrollRegionUp(
			    CurrentBuffer.b_windowPos,
			    CurrentBuffer.b_windowHeight,
			    CurrentBuffer.b_windowLine + 1);
			t := CurrentBuffer.b_windowHeight -
			     CurrentBuffer.b_windowLine - 1;
			CurrentBuffer.b_windowLine := 0;
			displayBottom(t);
		    fi;
		else
		    /* the last lines in the buffer are being excised */
		    CurrentBuffer.b_currentLine :=
			 CurrentBuffer.b_regionPtr*.l_prev;
		    if CurrentBuffer.b_currentLine = nil then
			/* buffer is now empty */
			CurrentBuffer.b_cursorLine := 1;
			displayNew();
		    else
			if CurrentBuffer.b_windowLine >= count then
			    CurrentBuffer.b_windowLine :=
				    CurrentBuffer.b_windowLine - count;
			    redraw();
			else
			    displayNew();
			fi;
		    fi;
		fi;
		TextLines := CurrentBuffer.b_regionPtr;
		/* the line we were pointing at has gone */
		CurrentBuffer.b_gotRegion := false;
		regionStatus();
	    else
		/* copying out a region of lines */
		temp := CurrentBuffer.b_currentLine*.l_next;
		CurrentBuffer.b_currentLine*.l_next := nil;
		pretend(buildCopy(CurrentBuffer.b_regionPtr, &TextLines,
				  &dummy), void);
		CurrentBuffer.b_currentLine*.l_next := temp;
	    fi;
	elif CurrentBuffer.b_cursorColumn > CurrentBuffer.b_regionColumn then
	    /* yanking out/copying a segment of the current line */
	    ch := CursorPos*;
	    CursorPos* := '\e';
	    TextChars := pretend(Malloc(CharsLen(
			CurrentBuffer.b_regionPos) + 1), *char);
	    if TextChars = nil then
		CursorPos* := ch;
		noSpace();
	    else
		GotText := true;
		CharsCopy(TextChars, CurrentBuffer.b_regionPos);
		CursorPos* := ch;
		if isYank then
		    deleteChunk(CurrentBuffer.b_regionPos, CursorPos, true);
		    CursorPos := CurrentBuffer.b_regionPos;
		    CurrentBuffer.b_cursorColumn :=
			 CurrentBuffer.b_regionColumn;
		fi;
	    fi;
	else
	    /* trying to get a region backwards - use this as a way to just
	       get rid of any current region */
	    CurrentBuffer.b_gotRegion := false;
	    regionStatus();
	fi;
    fi;
corp;

/*
 * putRegion - copy text from the text buffer into the file.
 */

proc putRegion()void:
    *LINELIST head, tail;

    if not GotText then
	noText();
    elif TextChars ~= nil then
	/* putting in some text into the current line. Note that the text was
	   taken in from an unFixed line, and so has no tabs in it. */
	insertChunk(TextChars, true);
    else
	/* putting in some whole lines before the current line. */
	fixLine();
	insertLines(buildCopy(TextLines, &head, &tail), head, tail);
    fi;
corp;

/*
 * fileRead - read from another file into this file.
 */

proc fileRead()void:
    *LINELIST head, tail;
    register ulong l1, l2;
    char ch;

    if getFileName("File to read: ") then
	l1 := getNumber("First line: ");
	if l1 ~= 0 then
	    l2 := getNumber("Last line: ");
	    if l2 >= l1 then
		if not open(Chin, Fyle, &LineBuffer[0]) then
		    putError("Can't open file.");
		else
		    l1 := l1 - 1;
		    l2 := l2 - l1;
		    while l1 ~= 0 do
			l1 := l1 - 1;
			while read(Chin; ch) do od;
			if ioerror(Chin) = CH_EOF then
			    l2 := 0;
			    l1 := 0;
			else
			    readln(Chin;);
			fi;
		    od;
		    if l2 ~= 0 then
			insertLines(readData(&head, &tail, l2), head, tail);
			close(Chin);
		    fi;
		fi;
	    fi;
	fi;
    fi;
corp;

/*
 * outputRegion - common code for fileWrite and printRegion.
 */

proc outputRegion(bool isPrint)void:
    *LINELIST temp;
    TABMODE tabModeSave;
    bool doIt;

    if not CurrentBuffer.b_gotRegion then
	noRegion();
    else
	if CurrentBuffer.b_cursorLine >= CurrentBuffer.b_regionLine then
	    fixLine();
	    temp := CurrentBuffer.b_currentLine*.l_next;
	    CurrentBuffer.b_currentLine*.l_next := nil;
	    doIt := true;
	    if isPrint then
		tabModeSave := CurrentBuffer.b_tabMode;
		CurrentBuffer.b_tabMode := BLANKS;
		open(Chout, Fyle, "PRT:");
	    else
		if getFileName("File to write: ") then
		    pretend(FileDestroy(&LineBuffer[0]), void);
		    if not FileCreate(&LineBuffer[0]) then
			putError("Can't create file.");
			doIt := false;
		    elif not open(Chout, Fyle, &LineBuffer[0]) then
			putError("Can't open file.");
			doIt := false;
		    fi;
		else
		    doIt := false;
		fi;
	    fi;
	    if doIt then
		pretend(writeFile(CurrentBuffer.b_regionPtr), void);
		/* writeFile closes the file when it's done */
	    fi;
	    CurrentBuffer.b_currentLine*.l_next := temp;
	    if isPrint then
		CurrentBuffer.b_tabMode := tabModeSave;
	    fi;
	fi;
    fi;
corp;

/*
 * adjustRegion - adjust the lines in a region by shifting or adjusting.
 */

proc adjustRegion(ushort operationCode)void:
    ulong currentSave, firstVisible;
    bool display;

    if not CurrentBuffer.b_gotRegion then
	noRegion();
    else
	if CurrentBuffer.b_cursorLine >= CurrentBuffer.b_regionLine then
	    CurrentBuffer.b_regionColumn := 0;
	    fixLine();
	    currentSave := CurrentBuffer.b_cursorLine;
	    firstVisible := currentSave - CurrentBuffer.b_windowLine;
	    display := CurrentBuffer.b_regionLine >= firstVisible;
	    if display then
		CurrentBuffer.b_windowLine :=
		    CurrentBuffer.b_regionLine - firstVisible;
	    fi;
	    CurrentBuffer.b_cursorLine := CurrentBuffer.b_regionLine;
	    CurrentBuffer.b_currentLine := CurrentBuffer.b_regionPtr;
	    while
		CurrentBuffer.b_cursorColumn := 0;
		unFixLine();
		if display then
		    update();
		fi;
		if operationCode = 0 then
		    adjustLine(display);
		elif operationCode = 1 then
		    deleteChunk(&LineBuffer[0], &LineBuffer[
			if LineLength < CurrentBuffer.b_indentIncrement then
			    LineLength
			else
			    CurrentBuffer.b_indentIncrement
			fi], display);
		else
		    insertBlanks(CurrentBuffer.b_indentIncrement, display);
		fi;
		fixLine();
		CurrentBuffer.b_cursorLine ~= currentSave
	    do
		CurrentBuffer.b_cursorLine := CurrentBuffer.b_cursorLine + 1;
		CurrentBuffer.b_currentLine :=
			CurrentBuffer.b_currentLine*.l_next;
		if display then
		    CurrentBuffer.b_windowLine :=
			CurrentBuffer.b_windowLine + 1;
		else
		    if CurrentBuffer.b_cursorLine = firstVisible then
			display := true;
			CurrentBuffer.b_windowLine := 0;
		    fi;
		fi;
	    od;
	fi;
    fi;
corp;

/*
 * formatRegion - the super magic format command!
 */

proc formatRegion()void:
    register *LINELIST l;
    register *char p;
    ushort column;
    register char ch, prevChar;
    register bool asIs;
    bool wrapSave, deleteMode;

    if not GotText or TextChars ~= nil then
	noText();
    else
	deleteMode := false;
	asIs := ask("Line by line (Y/N)? ");
	if asIs then
	    deleteMode := ask("Delete instead of insert (Y/N)? ");
	fi;
	wrapSave := CurrentBuffer.b_wrapMode;
	CurrentBuffer.b_wrapMode := true;
	unFixLine();
	column := CurrentBuffer.b_cursorColumn;
	fixPosition();
	if CurrentBuffer.b_cursorColumn < column then
	    update();
	    insertBlanks(column - CurrentBuffer.b_cursorColumn, true);
	else
	    CurrentBuffer.b_cursorColumn := column;
	    CursorPos := &LineBuffer[CurrentBuffer.b_cursorColumn];
	fi;
	l := TextLines;
	while l ~= nil do
	    p := l*.l_data;
	    ch := '\(0x80)';
	    prevChar := '\(0x80)';
	    while p* ~= '\e' do
		ch := p*;
		p := p + 1;
		if asIs or ch < '\(0x80)' or prevChar < '\(0x80)' then
		    update();
		    if deleteMode then
			deleteChar();
		    else
			dataChar(if ch >= '\(0x80)' then ' ' else ch fi);
		    fi;
		fi;
		prevChar := ch;
	    od;
	    if asIs then
		update();
		carriageReturn();
	    elif ch < '\(0x80)' then
		dataChar(' ');
	    fi;
	    l := l*.l_next;
	od;
	fixLine();
	CurrentBuffer.b_wrapMode := wrapSave;
    fi;
corp;
